int scene = 0;          //  現在のシーン番号
String message = "";    //  画面に表示するテキスト
PImage image = null;    //  画面に表示する画像

boolean button_pressed = false;  // ゲーム進行を管理するフラグの例

//
// 起動時に呼ばれる組み込み関数
//
void setup() {
  size(800,600);
}
 
//
// 毎フレーム呼ばれる組み込み関数
//
void draw() {
  set_message_and_image();
  
  if (image != null)
    image(image, 0, 0);
  
  textFont (createFont("MS Gothic",48,true));  // 文字のフォント
  fill(0);                                     // 文字の色
  textSize(24);                                // 文字のサイズ
  text(message,10, 500); 
}


//
// 今いるシーンに応じて、画像と文章をセットする。毎フレーム呼ばれる。
//
void set_message_and_image(){

  if (scene == 0){
      image =  loadImage("left.png");
      message = "今左側の部屋にいる\n";
      message += "1 : ドアを開けて外に出る\n";
      message += "2 : 右に移動する\n";
  }
  else if (scene == 1){
     // ボタンが押されているか否かで画像を変える
     if (button_pressed){
      image =  loadImage("right-pressed.png");
     }
     else {
      image =  loadImage("right.png");
     }
      message = "今右側の部屋にいる\n";
      message += "1 : ボタンを押す\n";
      message += "2 : 左に移動する\n";
  } 
  else if (scene == 2){
      image =  loadImage("end.png");
      message = "無事に外に出られた！\n";
  } 
  else if (scene == 3){
      image =  loadImage("left.png");
      message = "ドアがあかない\n";
      message += "1 : 戻る\n";
  } 
  

}


// 押されたキーに応じて、状態を更新する。
void keyTyped() {
  
  int selected = key - '0';  // 数字キーのコードを数字に変換
  
  if (scene == 0){
      if (selected == 1){
         // ボタンが押されているか否かで動作を変える
         if (button_pressed){
           scene = 2;
         }
         else {
           scene = 3;
         }
      }
      else if (selected == 2){
          scene = 1;    
      }
  }
  else if (scene == 1){
     if (selected == 1){
          button_pressed = true;  
     }
     else if (selected == 2){
          scene = 0;    
     }
   }  
  else if (scene == 3){
     if (selected == 1){
          scene = 0;  
     }
   }  
  
  
  // デバッグ用。状態をコンソールに出力する
  println("selected = "+selected);
  println("scene = "+scene);
  println("");
  

}